diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/buffer.c linux-2.4.22-ashuariadevel/fs/buffer.c
*** linux-2.4.22-ashuariadevel.backup/fs/buffer.c	2003-12-09 11:52:22.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/buffer.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 653,659 ****
  	spin_unlock(&lru_list_lock);
  }
  
! struct buffer_head * get_hash_table(kdev_t dev, int block, int size)
  {
  	struct buffer_head *bh, **p = &hash(dev, block);
  
--- 653,659 ----
  	spin_unlock(&lru_list_lock);
  }
  
! struct buffer_head * get_hash_table(kdev_t dev, sector_t block, int size)
  {
  	struct buffer_head *bh, **p = &hash(dev, block);
  
***************
*** 1063,1069 ****
   * 14.02.92: changed it to sync dirty buffers a bit: better performance
   * when the filesystem starts to get full of dirty blocks (I hope).
   */
! struct buffer_head * getblk(kdev_t dev, int block, int size)
  {
  	for (;;) {
  		struct buffer_head * bh;
--- 1063,1069 ----
   * 14.02.92: changed it to sync dirty buffers a bit: better performance
   * when the filesystem starts to get full of dirty blocks (I hope).
   */
! struct buffer_head * getblk(kdev_t dev, sector_t block, int size)
  {
  	for (;;) {
  		struct buffer_head * bh;
***************
*** 1239,1245 ****
   *	Reads a specified block, and returns buffer head that
   *	contains it. It returns NULL if the block was unreadable.
   */
! struct buffer_head * bread(kdev_t dev, int block, int size)
  {
  	struct buffer_head * bh;
  
--- 1239,1245 ----
   *	Reads a specified block, and returns buffer head that
   *	contains it. It returns NULL if the block was unreadable.
   */
! struct buffer_head * bread(kdev_t dev, sector_t block, int size)
  {
  	struct buffer_head * bh;
  
***************
*** 1678,1684 ****
  		unsigned from, unsigned to, get_block_t *get_block)
  {
  	unsigned block_start, block_end;
! 	unsigned long block;
  	int err = 0;
  	unsigned blocksize, bbits;
  	struct buffer_head *bh, *head, *wait[2], **wait_bh=wait;
--- 1678,1684 ----
  		unsigned from, unsigned to, get_block_t *get_block)
  {
  	unsigned block_start, block_end;
! 	sector_t block;
  	int err = 0;
  	unsigned blocksize, bbits;
  	struct buffer_head *bh, *head, *wait[2], **wait_bh=wait;
***************
*** 1690,1696 ****
  	head = page->buffers;
  
  	bbits = inode->i_blkbits;
! 	block = page->index << (PAGE_CACHE_SHIFT - bbits);
  
  	for(bh = head, block_start = 0; bh != head || !block_start;
  	    block++, block_start=block_end, bh = bh->b_this_page) {
--- 1690,1696 ----
  	head = page->buffers;
  
  	bbits = inode->i_blkbits;
! 	block = (sector_t)page->index << (PAGE_CACHE_SHIFT - bbits);
  
  	for(bh = head, block_start = 0; bh != head || !block_start;
  	    block++, block_start=block_end, bh = bh->b_this_page) {
***************
*** 1829,1835 ****
  int block_read_full_page(struct page *page, get_block_t *get_block)
  {
  	struct inode *inode = page->mapping->host;
! 	unsigned long iblock, lblock;
  	struct buffer_head *bh, *head, *arr[MAX_BUF_PER_PAGE];
  	unsigned int blocksize, blocks;
  	int nr, i;
--- 1829,1835 ----
  int block_read_full_page(struct page *page, get_block_t *get_block)
  {
  	struct inode *inode = page->mapping->host;
! 	sector_t iblock, lblock;
  	struct buffer_head *bh, *head, *arr[MAX_BUF_PER_PAGE];
  	unsigned int blocksize, blocks;
  	int nr, i;
***************
*** 1842,1848 ****
  	head = page->buffers;
  
  	blocks = PAGE_CACHE_SIZE >> inode->i_blkbits;
! 	iblock = page->index << (PAGE_CACHE_SHIFT - inode->i_blkbits);
  	lblock = (inode->i_size+blocksize-1) >> inode->i_blkbits;
  	bh = head;
  	nr = 0;
--- 1842,1848 ----
  	head = page->buffers;
  
  	blocks = PAGE_CACHE_SIZE >> inode->i_blkbits;
! 	iblock = (sector_t)page->index << (PAGE_CACHE_SHIFT - inode->i_blkbits);
  	lblock = (inode->i_size+blocksize-1) >> inode->i_blkbits;
  	bh = head;
  	nr = 0;
***************
*** 2227,2233 ****
  }
  EXPORT_SYMBOL(waitfor_one_page);
  
! int generic_block_bmap(struct address_space *mapping, long block, get_block_t *get_block)
  {
  	struct buffer_head tmp;
  	struct inode *inode = mapping->host;
--- 2227,2233 ----
  }
  EXPORT_SYMBOL(waitfor_one_page);
  
! sector_t generic_block_bmap(struct address_space *mapping, sector_t block, get_block_t *get_block)
  {
  	struct buffer_head tmp;
  	struct inode *inode = mapping->host;
***************
*** 2237,2246 ****
  	return tmp.b_blocknr;
  }
  
! int generic_direct_IO(int rw, struct inode * inode, struct kiobuf * iobuf, unsigned long blocknr, int blocksize, get_block_t * get_block)
  {
  	int i, nr_blocks, retval;
! 	unsigned long * blocks = iobuf->blocks;
  	int length;
  	int beyond_eof = 0;
  	
--- 2237,2248 ----
  	return tmp.b_blocknr;
  }
  
! int generic_direct_IO(int rw, struct inode * inode, 
! 		      struct kiobuf * iobuf, sector_t blocknr, 
! 		      int blocksize, get_block_t * get_block)
  {
  	int i, nr_blocks, retval;
! 	sector_t *blocks = iobuf->blocks;
  	int length;
  	int beyond_eof = 0;
  	
***************
*** 2277,2283 ****
  				BUG();
  			if (!buffer_mapped(&bh)) {
  				/* there was an hole in the filesystem */
! 				blocks[i] = -1UL;
  				continue;
  			}
  		} else {
--- 2279,2285 ----
  				BUG();
  			if (!buffer_mapped(&bh)) {
  				/* there was an hole in the filesystem */
! 				blocks[i] = ~(sector_t)0;
  				continue;
  			}
  		} else {
***************
*** 2368,2374 ****
   */
  
  int brw_kiovec(int rw, int nr, struct kiobuf *iovec[], 
! 	       kdev_t dev, unsigned long b[], int size)
  {
  	int		err;
  	int		length;
--- 2370,2376 ----
   */
  
  int brw_kiovec(int rw, int nr, struct kiobuf *iovec[], 
! 	       kdev_t dev, sector_t b[], int size)
  {
  	int		err;
  	int		length;
***************
*** 2378,2384 ****
  	int		pageind;
  	int		bhind;
  	int		offset;
! 	unsigned long	blocknr;
  	struct kiobuf *	iobuf = NULL;
  	struct page *	map;
  	struct buffer_head *tmp, **bhs = NULL;
--- 2380,2386 ----
  	int		pageind;
  	int		bhind;
  	int		offset;
! 	sector_t	blocknr;
  	struct kiobuf *	iobuf = NULL;
  	struct page *	map;
  	struct buffer_head *tmp, **bhs = NULL;
***************
*** 2503,2509 ****
   * FIXME: we need a swapper_inode->get_block function to remove
   *        some of the bmap kludges and interface ugliness here.
   */
! int brw_page(int rw, struct page *page, kdev_t dev, int b[], int size)
  {
  	struct buffer_head *head, *bh;
  
--- 2505,2511 ----
   * FIXME: we need a swapper_inode->get_block function to remove
   *        some of the bmap kludges and interface ugliness here.
   */
! int brw_page(int rw, struct page *page, kdev_t dev, sector_t b[], int size)
  {
  	struct buffer_head *head, *bh;
  
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/efs/file.c linux-2.4.22-ashuariadevel/fs/efs/file.c
*** linux-2.4.22-ashuariadevel.backup/fs/efs/file.c	2000-02-27 13:33:05.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/efs/file.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 8,14 ****
  
  #include <linux/efs_fs.h>
  
! int efs_get_block(struct inode *inode, long iblock,
  		  struct buffer_head *bh_result, int create)
  {
  	int error = -EROFS;
--- 8,14 ----
  
  #include <linux/efs_fs.h>
  
! int efs_get_block(struct inode *inode, sector_t iblock,
  		  struct buffer_head *bh_result, int create)
  {
  	int error = -EROFS;
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/efs/inode.c linux-2.4.22-ashuariadevel/fs/efs/inode.c
*** linux-2.4.22-ashuariadevel.backup/fs/efs/inode.c	2002-02-26 04:38:08.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/efs/inode.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 12,23 ****
  #include <linux/module.h>
  
  
! extern int efs_get_block(struct inode *, long, struct buffer_head *, int);
  static int efs_readpage(struct file *file, struct page *page)
  {
  	return block_read_full_page(page,efs_get_block);
  }
! static int _efs_bmap(struct address_space *mapping, long block)
  {
  	return generic_block_bmap(mapping,block,efs_get_block);
  }
--- 12,23 ----
  #include <linux/module.h>
  
  
! extern int efs_get_block(struct inode *, sector_t, struct buffer_head *, int);
  static int efs_readpage(struct file *file, struct page *page)
  {
  	return block_read_full_page(page,efs_get_block);
  }
! static sector_t _efs_bmap(struct address_space *mapping, sector_t block)
  {
  	return generic_block_bmap(mapping,block,efs_get_block);
  }
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/ext2/inode.c linux-2.4.22-ashuariadevel/fs/ext2/inode.c
*** linux-2.4.22-ashuariadevel.backup/fs/ext2/inode.c	2003-06-13 23:51:37.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/ext2/inode.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 505,511 ****
   * reachable from inode.
   */
  
! static int ext2_get_block(struct inode *inode, long iblock, struct buffer_head *bh_result, int create)
  {
  	int err = -EIO;
  	int offsets[4];
--- 505,511 ----
   * reachable from inode.
   */
  
! static int ext2_get_block(struct inode *inode, sector_t iblock, struct buffer_head *bh_result, int create)
  {
  	int err = -EIO;
  	int offsets[4];
***************
*** 588,598 ****
  {
  	return block_prepare_write(page,from,to,ext2_get_block);
  }
! static int ext2_bmap(struct address_space *mapping, long block)
  {
  	return generic_block_bmap(mapping,block,ext2_get_block);
  }
! static int ext2_direct_IO(int rw, struct inode * inode, struct kiobuf * iobuf, unsigned long blocknr, int blocksize)
  {
  	return generic_direct_IO(rw, inode, iobuf, blocknr, blocksize, ext2_get_block);
  }
--- 588,599 ----
  {
  	return block_prepare_write(page,from,to,ext2_get_block);
  }
! static sector_t ext2_bmap(struct address_space *mapping, sector_t block)
  {
  	return generic_block_bmap(mapping,block,ext2_get_block);
  }
! static int ext2_direct_IO(int rw, struct inode * inode, struct kiobuf * iobuf,
! 			  sector_t blocknr, int blocksize)
  {
  	return generic_direct_IO(rw, inode, iobuf, blocknr, blocksize, ext2_get_block);
  }
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/ext3/ialloc.c linux-2.4.22-ashuariadevel/fs/ext3/ialloc.c
*** linux-2.4.22-ashuariadevel.backup/fs/ext3/ialloc.c	2003-06-13 23:51:37.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/ext3/ialloc.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 563,570 ****
  	    is_bad_inode(inode) || NEXT_ORPHAN(inode) > max_ino) {
  		ext3_warning(sb, __FUNCTION__,
  			     "bad orphan inode %lu!  e2fsck was run?\n", ino);
! 		printk(KERN_NOTICE "ext3_test_bit(bit=%d, block=%ld) = %d\n",
! 		       bit, bh->b_blocknr, ext3_test_bit(bit, bh->b_data));
  		printk(KERN_NOTICE "inode=%p\n", inode);
  		if (inode) {
  			printk(KERN_NOTICE "is_bad_inode(inode)=%d\n",
--- 563,570 ----
  	    is_bad_inode(inode) || NEXT_ORPHAN(inode) > max_ino) {
  		ext3_warning(sb, __FUNCTION__,
  			     "bad orphan inode %lu!  e2fsck was run?\n", ino);
! 		printk(KERN_NOTICE "ext3_test_bit(bit=%d, block=%llu) = %d\n",
! 		       bit, (unsigned long long)bh->b_blocknr, ext3_test_bit(bit, bh->b_data));
  		printk(KERN_NOTICE "inode=%p\n", inode);
  		if (inode) {
  			printk(KERN_NOTICE "is_bad_inode(inode)=%d\n",
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/ext3/inode.c linux-2.4.22-ashuariadevel/fs/ext3/inode.c
*** linux-2.4.22-ashuariadevel.backup/fs/ext3/inode.c	2003-12-09 11:52:21.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/ext3/inode.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 840,846 ****
  /*
   * The BKL is not held on entry here.
   */
! static int ext3_get_block(struct inode *inode, long iblock,
  			struct buffer_head *bh_result, int create)
  {
  	handle_t *handle = 0;
--- 840,846 ----
  /*
   * The BKL is not held on entry here.
   */
! static int ext3_get_block(struct inode *inode, sector_t iblock,
  			struct buffer_head *bh_result, int create)
  {
  	handle_t *handle = 0;
***************
*** 1182,1188 ****
   * So, if we see any bmap calls here on a modified, data-journaled file,
   * take extra steps to flush any blocks which might be in the cache. 
   */
! static int ext3_bmap(struct address_space *mapping, long block)
  {
  	struct inode *inode = mapping->host;
  	journal_t *journal;
--- 1182,1188 ----
   * So, if we see any bmap calls here on a modified, data-journaled file,
   * take extra steps to flush any blocks which might be in the cache. 
   */
! static sector_t ext3_bmap(struct address_space *mapping, sector_t block)
  {
  	struct inode *inode = mapping->host;
  	journal_t *journal;
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/fat/file.c linux-2.4.22-ashuariadevel/fs/fat/file.c
*** linux-2.4.22-ashuariadevel.backup/fs/fat/file.c	2001-08-13 02:56:56.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/fat/file.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 48,58 ****
  }
  
  
! int fat_get_block(struct inode *inode, long iblock, struct buffer_head *bh_result, int create)
  {
  	struct super_block *sb = inode->i_sb;
  	unsigned long phys;
  
  	phys = fat_bmap(inode, iblock);
  	if (phys) {
  		bh_result->b_dev = inode->i_dev;
--- 48,60 ----
  }
  
  
! int fat_get_block(struct inode *inode, sector_t iblock, struct buffer_head *bh_result, int create)
  {
  	struct super_block *sb = inode->i_sb;
  	unsigned long phys;
  
+ 	BUG_ON(sizeof(iblock) > 4 && (iblock>>32));
+ 
  	phys = fat_bmap(inode, iblock);
  	if (phys) {
  		bh_result->b_dev = inode->i_dev;
***************
*** 66,72 ****
  		BUG();
  		return -EIO;
  	}
! 	if (!(iblock % MSDOS_SB(inode->i_sb)->cluster_size)) {
  		if (fat_add_cluster(inode) < 0)
  			return -ENOSPC;
  	}
--- 68,74 ----
  		BUG();
  		return -EIO;
  	}
! 	if (!((unsigned long)iblock % MSDOS_SB(inode->i_sb)->cluster_size)) {
  		if (fat_add_cluster(inode) < 0)
  			return -ENOSPC;
  	}
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/fat/inode.c linux-2.4.22-ashuariadevel/fs/fat/inode.c
*** linux-2.4.22-ashuariadevel.backup/fs/fat/inode.c	2003-08-25 20:44:43.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/fat/inode.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 870,876 ****
  	return cont_prepare_write(page,from,to,fat_get_block,
  		&MSDOS_I(page->mapping->host)->mmu_private);
  }
! static int _fat_bmap(struct address_space *mapping, long block)
  {
  	return generic_block_bmap(mapping,block,fat_get_block);
  }
--- 870,876 ----
  	return cont_prepare_write(page,from,to,fat_get_block,
  		&MSDOS_I(page->mapping->host)->mmu_private);
  }
! static sector_t _fat_bmap(struct address_space *mapping, sector_t block)
  {
  	return generic_block_bmap(mapping,block,fat_get_block);
  }
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/fat/misc.c linux-2.4.22-ashuariadevel/fs/fat/misc.c
*** linux-2.4.22-ashuariadevel.backup/fs/fat/misc.c	2003-08-25 20:44:43.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/fat/misc.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 183,192 ****
  		mark_inode_dirty(inode);
  	}
  	if (file_cluster
! 	    != inode->i_blocks / cluster_size / (sb->s_blocksize / 512)) {
  		printk ("file_cluster badly computed!!! %d <> %ld\n",
  			file_cluster,
! 			inode->i_blocks / cluster_size / (sb->s_blocksize / 512));
  		fat_cache_inval_inode(inode);
  	}
  	inode->i_blocks += (1 << MSDOS_SB(sb)->cluster_bits) / 512;
--- 183,192 ----
  		mark_inode_dirty(inode);
  	}
  	if (file_cluster
! 	    != (long)inode->i_blocks / cluster_size / (sb->s_blocksize / 512)) {
  		printk ("file_cluster badly computed!!! %d <> %ld\n",
  			file_cluster,
! 			(long)inode->i_blocks / cluster_size / (sb->s_blocksize / 512));
  		fat_cache_inval_inode(inode);
  	}
  	inode->i_blocks += (1 << MSDOS_SB(sb)->cluster_bits) / 512;
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/freevxfs/vxfs_kcompat.h linux-2.4.22-ashuariadevel/fs/freevxfs/vxfs_kcompat.h
*** linux-2.4.22-ashuariadevel.backup/fs/freevxfs/vxfs_kcompat.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/freevxfs/vxfs_kcompat.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 7,16 ****
  
  #include <linux/blkdev.h>
  
- typedef long sector_t;
- 
  /* Dito.  */
! static inline void map_bh(struct buffer_head *bh, struct super_block *sb, int block)
  {
  	bh->b_state |= 1 << BH_Mapped;
  	bh->b_dev = sb->s_dev;
--- 7,14 ----
  
  #include <linux/blkdev.h>
  
  /* Dito.  */
! static inline void map_bh(struct buffer_head *bh, struct super_block *sb, sector_t block)
  {
  	bh->b_state |= 1 << BH_Mapped;
  	bh->b_dev = sb->s_dev;
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/freevxfs/vxfs_subr.c linux-2.4.22-ashuariadevel/fs/freevxfs/vxfs_subr.c
*** linux-2.4.22-ashuariadevel.backup/fs/freevxfs/vxfs_subr.c	2002-02-26 04:38:08.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/freevxfs/vxfs_subr.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 42,48 ****
  
  
  static int		vxfs_readpage(struct file *, struct page *);
! static int		vxfs_bmap(struct address_space *, long);
  
  struct address_space_operations vxfs_aops = {
  	.readpage =		vxfs_readpage,
--- 42,48 ----
  
  
  static int		vxfs_readpage(struct file *, struct page *);
! static sector_t		vxfs_bmap(struct address_space *, sector_t);
  
  struct address_space_operations vxfs_aops = {
  	.readpage =		vxfs_readpage,
***************
*** 185,192 ****
   * Locking status:
   *   We are under the bkl.
   */
! static int
! vxfs_bmap(struct address_space *mapping, long block)
  {
  	return generic_block_bmap(mapping, block, vxfs_getblk);
  }
--- 185,192 ----
   * Locking status:
   *   We are under the bkl.
   */
! static sector_t
! vxfs_bmap(struct address_space *mapping, sector_t block)
  {
  	return generic_block_bmap(mapping, block, vxfs_getblk);
  }
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/hfs/file.c linux-2.4.22-ashuariadevel/fs/hfs/file.c
*** linux-2.4.22-ashuariadevel.backup/fs/hfs/file.c	2002-02-26 04:38:08.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/hfs/file.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 106,112 ****
   * block number.  This function just calls hfs_extent_map() to do the
   * real work and then stuffs the appropriate info into the buffer_head.
   */
! int hfs_get_block(struct inode *inode, long iblock, struct buffer_head *bh_result, int create)
  {
  	unsigned long phys;
  
--- 106,112 ----
   * block number.  This function just calls hfs_extent_map() to do the
   * real work and then stuffs the appropriate info into the buffer_head.
   */
! int hfs_get_block(struct inode *inode, sector_t iblock, struct buffer_head *bh_result, int create)
  {
  	unsigned long phys;
  
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/hfs/hfs.h linux-2.4.22-ashuariadevel/fs/hfs/hfs.h
*** linux-2.4.22-ashuariadevel.backup/fs/hfs/hfs.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/hfs/hfs.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 495,501 ****
  extern void hfs_extent_free(struct hfs_fork *);
  
  /* file.c */
! extern int hfs_get_block(struct inode *, long, struct buffer_head *, int);
  
  /* mdb.c */
  extern struct hfs_mdb *hfs_mdb_get(hfs_sysmdb, int, hfs_s32);
--- 495,501 ----
  extern void hfs_extent_free(struct hfs_fork *);
  
  /* file.c */
! extern int hfs_get_block(struct inode *, sector_t, struct buffer_head *, int);
  
  /* mdb.c */
  extern struct hfs_mdb *hfs_mdb_get(hfs_sysmdb, int, hfs_s32);
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/hfs/inode.c linux-2.4.22-ashuariadevel/fs/hfs/inode.c
*** linux-2.4.22-ashuariadevel.backup/fs/hfs/inode.c	2001-09-13 07:34:06.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/hfs/inode.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 235,241 ****
  	return cont_prepare_write(page,from,to,hfs_get_block,
  		&page->mapping->host->u.hfs_i.mmu_private);
  }
! static int hfs_bmap(struct address_space *mapping, long block)
  {
  	return generic_block_bmap(mapping,block,hfs_get_block);
  }
--- 235,241 ----
  	return cont_prepare_write(page,from,to,hfs_get_block,
  		&page->mapping->host->u.hfs_i.mmu_private);
  }
! static sector_t hfs_bmap(struct address_space *mapping, sector_t block)
  {
  	return generic_block_bmap(mapping,block,hfs_get_block);
  }
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/hfsplus/extents.c linux-2.4.22-ashuariadevel/fs/hfsplus/extents.c
*** linux-2.4.22-ashuariadevel.backup/fs/hfsplus/extents.c	2003-08-25 20:44:43.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/hfsplus/extents.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 128,134 ****
  
  	if (!dblock)
  		return -EIO;
! 	dprint(DBG_EXTENT, "get_block(%lu): %lu - %u\n", inode->i_ino, iblock, dblock);
  
  	map_bh(bh_result, sb, dblock + HFSPLUS_SB(sb).blockoffset);
  	if (create)
--- 128,134 ----
  
  	if (!dblock)
  		return -EIO;
! 	dprint(DBG_EXTENT, "get_block(%lu): %llu - %u\n", inode->i_ino, (unsigned long long)iblock, dblock);
  
  	map_bh(bh_result, sb, dblock + HFSPLUS_SB(sb).blockoffset);
  	if (create)
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/hfsplus/hfsplus_fs.h linux-2.4.22-ashuariadevel/fs/hfsplus/hfsplus_fs.h
*** linux-2.4.22-ashuariadevel.backup/fs/hfsplus/hfsplus_fs.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/hfsplus/hfsplus_fs.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 211,219 ****
  	hfsplus_cat_key key;
  };
  
- #if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
- typedef long sector_t;
- #endif
  
  /*
   * Functions in any *.c used in other files
--- 211,216 ----
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/hfsplus/inode.c linux-2.4.22-ashuariadevel/fs/hfsplus/inode.c
*** linux-2.4.22-ashuariadevel.backup/fs/hfsplus/inode.c	2003-08-25 20:44:43.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/hfsplus/inode.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 45,55 ****
  		&HFSPLUS_I(page->mapping->host).mmu_private);
  }
  
- #if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
- static int hfsplus_bmap(struct address_space *mapping, long block)
- #else
  static sector_t hfsplus_bmap(struct address_space *mapping, sector_t block)
- #endif
  {
  	return generic_block_bmap(mapping, block, hfsplus_get_block);
  }
--- 45,51 ----
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/hpfs/file.c linux-2.4.22-ashuariadevel/fs/hpfs/file.c
*** linux-2.4.22-ashuariadevel.backup/fs/hpfs/file.c	2001-08-13 09:37:53.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/hpfs/file.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 68,74 ****
  	hpfs_write_inode(i);
  }
  
! int hpfs_get_block(struct inode *inode, long iblock, struct buffer_head *bh_result, int create)
  {
  	secno s;
  	s = hpfs_bmap(inode, iblock);
--- 68,74 ----
  	hpfs_write_inode(i);
  }
  
! int hpfs_get_block(struct inode *inode, sector_t iblock, struct buffer_head *bh_result, int create)
  {
  	secno s;
  	s = hpfs_bmap(inode, iblock);
***************
*** 108,114 ****
  	return cont_prepare_write(page,from,to,hpfs_get_block,
  		&page->mapping->host->u.hpfs_i.mmu_private);
  }
! static int _hpfs_bmap(struct address_space *mapping, long block)
  {
  	return generic_block_bmap(mapping,block,hpfs_get_block);
  }
--- 108,114 ----
  	return cont_prepare_write(page,from,to,hpfs_get_block,
  		&page->mapping->host->u.hpfs_i.mmu_private);
  }
! static sector_t _hpfs_bmap(struct address_space *mapping, sector_t block)
  {
  	return generic_block_bmap(mapping,block,hpfs_get_block);
  }
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/hpfs/hpfs_fn.h linux-2.4.22-ashuariadevel/fs/hpfs/hpfs_fn.h
*** linux-2.4.22-ashuariadevel.backup/fs/hpfs/hpfs_fn.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/hpfs/hpfs_fn.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 261,267 ****
  int hpfs_file_fsync(struct file *, struct dentry *, int);
  secno hpfs_bmap(struct inode *, unsigned);
  void hpfs_truncate(struct inode *);
! int hpfs_get_block(struct inode *inode, long iblock, struct buffer_head *bh_result, int create);
  ssize_t hpfs_file_write(struct file *file, const char *buf, size_t count, loff_t *ppos);
  
  /* inode.c */
--- 261,267 ----
  int hpfs_file_fsync(struct file *, struct dentry *, int);
  secno hpfs_bmap(struct inode *, unsigned);
  void hpfs_truncate(struct inode *);
! int hpfs_get_block(struct inode *inode, sector_t iblock, struct buffer_head *bh_result, int create);
  ssize_t hpfs_file_write(struct file *file, const char *buf, size_t count, loff_t *ppos);
  
  /* inode.c */
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/inode.c linux-2.4.22-ashuariadevel/fs/inode.c
*** linux-2.4.22-ashuariadevel.backup/fs/inode.c	2003-12-09 11:52:21.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/inode.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 1116,1124 ****
   *	file.
   */
   
! int bmap(struct inode * inode, int block)
  {
! 	int res = 0;
  	if (inode->i_mapping->a_ops->bmap)
  		res = inode->i_mapping->a_ops->bmap(inode->i_mapping, block);
  	return res;
--- 1116,1124 ----
   *	file.
   */
   
! sector_t bmap(struct inode * inode, sector_t block)
  {
! 	sector_t res = 0;
  	if (inode->i_mapping->a_ops->bmap)
  		res = inode->i_mapping->a_ops->bmap(inode->i_mapping, block);
  	return res;
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/intermezzo/journal_ext3.c linux-2.4.22-ashuariadevel/fs/intermezzo/journal_ext3.c
*** linux-2.4.22-ashuariadevel.backup/fs/intermezzo/journal_ext3.c	2002-11-29 08:53:15.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/intermezzo/journal_ext3.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 262,268 ****
  
          block *= (inode->i_sb->s_blocksize / 512);
  
!         CDEBUG(D_CACHE, "Need %ld blocks, have %ld.\n", block, inode->i_blocks);
  
          if (block > inode->i_blocks) {
                  EXIT;
--- 262,268 ----
  
          block *= (inode->i_sb->s_blocksize / 512);
  
!         CDEBUG(D_CACHE, "Need %llu blocks, have %llu.\n", (unsigned long long)block, (unsigned long long)inode->i_blocks);
  
          if (block > inode->i_blocks) {
                  EXIT;
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/isofs/inode.c linux-2.4.22-ashuariadevel/fs/isofs/inode.c
*** linux-2.4.22-ashuariadevel.backup/fs/isofs/inode.c	2002-11-29 08:53:15.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/isofs/inode.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 976,982 ****
  /*
   * Used by the standard interfaces.
   */
! static int isofs_get_block(struct inode *inode, long iblock,
  		    struct buffer_head *bh_result, int create)
  {
  	if ( create ) {
--- 976,982 ----
  /*
   * Used by the standard interfaces.
   */
! static int isofs_get_block(struct inode *inode, sector_t iblock,
  		    struct buffer_head *bh_result, int create)
  {
  	if ( create ) {
***************
*** 984,993 ****
  		return -EROFS;
  	}
  
! 	return isofs_get_blocks(inode, iblock, &bh_result, 1) ? 0 : -EIO;
  }
  
! static int isofs_bmap(struct inode *inode, int block)
  {
  	struct buffer_head dummy;
  	int error;
--- 984,994 ----
  		return -EROFS;
  	}
  
! 	BUG_ON(sizeof(iblock) > 4 && (iblock >> 32));
! 	return isofs_get_blocks(inode, (long)iblock, &bh_result, 1) ? 0 : -EIO;
  }
  
! static int isofs_bmap(struct inode *inode, sector_t block)
  {
  	struct buffer_head dummy;
  	int error;
***************
*** 1000,1006 ****
  	return 0;
  }
  
! struct buffer_head *isofs_bread(struct inode *inode, unsigned int block)
  {
  	unsigned int blknr = isofs_bmap(inode, block);
  	if (!blknr)
--- 1001,1007 ----
  	return 0;
  }
  
! struct buffer_head *isofs_bread(struct inode *inode, sector_t block)
  {
  	unsigned int blknr = isofs_bmap(inode, block);
  	if (!blknr)
***************
*** 1013,1019 ****
  	return block_read_full_page(page,isofs_get_block);
  }
  
! static int _isofs_bmap(struct address_space *mapping, long block)
  {
  	return generic_block_bmap(mapping,block,isofs_get_block);
  }
--- 1014,1020 ----
  	return block_read_full_page(page,isofs_get_block);
  }
  
! static sector_t _isofs_bmap(struct address_space *mapping, sector_t block)
  {
  	return generic_block_bmap(mapping,block,isofs_get_block);
  }
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/jbd/commit.c linux-2.4.22-ashuariadevel/fs/jbd/commit.c
*** linux-2.4.22-ashuariadevel.backup/fs/jbd/commit.c	2003-12-09 11:52:21.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/jbd/commit.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 373,380 ****
  			}
  			
  			bh = jh2bh(descriptor);
! 			jbd_debug(4, "JBD: got buffer %ld (%p)\n",
! 				bh->b_blocknr, bh->b_data);
  			header = (journal_header_t *)&bh->b_data[0];
  			header->h_magic     = htonl(JFS_MAGIC_NUMBER);
  			header->h_blocktype = htonl(JFS_DESCRIPTOR_BLOCK);
--- 373,380 ----
  			}
  			
  			bh = jh2bh(descriptor);
! 			jbd_debug(4, "JBD: got buffer %llu (%p)\n",
! 				(unsigned long long)bh->b_blocknr, bh->b_data);
  			header = (journal_header_t *)&bh->b_data[0];
  			header->h_magic     = htonl(JFS_MAGIC_NUMBER);
  			header->h_blocktype = htonl(JFS_DESCRIPTOR_BLOCK);
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/jbd/journal.c linux-2.4.22-ashuariadevel/fs/jbd/journal.c
*** linux-2.4.22-ashuariadevel.backup/fs/jbd/journal.c	2003-12-09 11:52:13.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/jbd/journal.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 1587,1595 ****
  	
  	if (buffer_dirty(bh)) {
  		printk ("%sUnexpected dirty buffer encountered at "
! 			"%s:%d (%s blocknr %lu)\n",
  			KERN_WARNING, function, line,
! 			kdevname(bh->b_dev), bh->b_blocknr);
  #ifdef JBD_PARANOID_WRITES
  		J_ASSERT_BH (bh, !buffer_dirty(bh));
  #endif	
--- 1587,1595 ----
  	
  	if (buffer_dirty(bh)) {
  		printk ("%sUnexpected dirty buffer encountered at "
! 			"%s:%d (%s blocknr %llu)\n",
  			KERN_WARNING, function, line,
! 			kdevname(bh->b_dev), (unsigned long long)bh->b_blocknr);
  #ifdef JBD_PARANOID_WRITES
  		J_ASSERT_BH (bh, !buffer_dirty(bh));
  #endif	
diff -Ncr linux-2.4.22-ashuariadevel.backup/fs/jbd/revoke.c linux-2.4.22-ashuariadevel/fs/jbd/revoke.c
*** linux-2.4.22-ashuariadevel.backup/fs/jbd/revoke.c	2003-06-13 23:51:37.000000000 +0900
--- linux-2.4.22-ashuariadevel/fs/jbd/revoke.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 389,395 ****
  		record = find_revoke_record(journal, bh->b_blocknr);
  		if (record) {
  			jbd_debug(4, "cancelled existing revoke on "
! 				  "blocknr %lu\n", bh->b_blocknr);
  			list_del(&record->hash);
  			kmem_cache_free(revoke_record_cache, record);
  			did_revoke = 1;
--- 389,395 ----
  		record = find_revoke_record(journal, bh->b_blocknr);
  		if (record) {
  			jbd_debug(4, "cancelled existing revoke on "
! 				  "blocknr %llu\n", (unsigned long long)bh->b_blocknr);
  			list_del(&record->hash);
  			kmem_cache_free(revoke_record_cache, record);
  			did_revoke = 1;
